# TODO:
# - system libuv?
# - fix tests
#
# Conditional build:
%bcond_without	doc	# API documentation
%bcond_with	tests	# unit tests (some failures, many need network)

Summary:	Fast implementation of asyncio event loop on top of libuv
Summary(pl.UTF-8):	Szybka implementacja pętli zdarzeń asyncio oparta na libuv
Name:		python3-uvloop
Version:	0.21.0
Release:	1
License:	MIT or Apache v2.0
Group:		Libraries/Python
#Source0Download: https://pypi.org/simple/uvloop/
Source0:	https://files.pythonhosted.org/packages/source/u/uvloop/uvloop-%{version}.tar.gz
# Source0-md5:	adedf20cf065ff49a96813b783ec1d29
URL:		https://pypi.org/project/uvloop/
BuildRequires:	python3-Cython >= 3.0
BuildRequires:	python3-devel >= 1:3.8
BuildRequires:	python3-setuptools >= 1:60
%if %{with tests}
BuildRequires:	python3-aiohttp >= 3.10.5
BuildRequires:	python3-flake8 >= 5.0
BuildRequires:	python3-mypy >= 0.800
BuildRequires:	python3-psutil
BuildRequires:	python3-pycodestyle >= 2.9.0
BuildRequires:	python3-pyOpenSSL >= 23.0.0
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with doc}
BuildRequires:	python3-sphinx_rtd_theme >= 0.5.2
BuildRequires:	python3-sphinxcontrib-asyncio >= 0.3.0
BuildRequires:	sphinx-pdg-3 >= 4.1.2
%endif
Requires:	python3-modules >= 1:3.8
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
uvloop is a fast, drop-in replacement of the built-in asyncio event
loop. uvloop is implemented in Cython and uses libuv under the hood.

%description -l pl.UTF-8
uvloop jest szybkim zamiennikiem wbudowanej pętli zdarzeń asyncio.
Jest zaimplementowany w Cythonie i wykorzystuje libuv.

%package apidocs
Summary:	API documentation for Python uvloop module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona uvloop
Group:		Documentation

%description apidocs
API documentation for Python uvloop module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona uvloop.

%prep
%setup -q -n uvloop-%{version}

%build
%py3_build

%if %{with tests}
%{__mv} uvloop{,.away}
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTEST_PLUGINS= \
PYTHONPATH=$(echo $(pwd)/build-3/lib.*) \
%{__python3} -m pytest tests
%{__mv} uvloop{.away,}
%endif

%if %{with doc}
sphinx-build-3 -b html docs docs/_build/html
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py3_install

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc LICENSE-MIT README.rst
%dir %{py3_sitedir}/uvloop
%attr(755,root,root) %{py3_sitedir}/uvloop/loop.cpython-*.so
%{py3_sitedir}/uvloop/*.py
%{py3_sitedir}/uvloop/*.pxd
%{py3_sitedir}/uvloop/*.pyi
%{py3_sitedir}/uvloop/*.pyx
%{py3_sitedir}/uvloop/py.typed
%{py3_sitedir}/uvloop/__pycache__
%{py3_sitedir}/uvloop/handles
%{py3_sitedir}/uvloop/includes
%{py3_sitedir}/uvloop-%{version}-py*.egg-info

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/_build/html/{_static,api,dev,user,*.html,*.js}
%endif
%changelog
* Sun Jul 06 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-uvloop.git;a=log;h=master

* Sat Jul 05 2025 Jakub Bogusz <qboosh@pld-linux.org> c28799f
- initial

